Scriptname zMFqMainScript extends Quest  

;-------------------------------------------------
;Properties
;-------------------------------------------------
MiscObject Property TokenTrained  Auto 
MiscObject Property TokenProductive  Auto  
MiscObject Property TokenMotivation  Auto  
MiscObject Property TokenEstrus  Auto  
MiscObject Property TokenMilk  Auto  

FormList Property ListCreatureVoice  Auto  
FormList Property ListHarvestCreature  Auto  
FormList Property ListHarvestHuman  Auto  
FormList Property ListMilk  Auto 

ObjectReference Property BlankNameObject  Auto  

LeveledItem Property LItemDefault  Auto  
LeveledItem Property LItemToken  Auto  

Keyword Property ActorTypeUndead  Auto 
Keyword Property ActorTypeDaedra  Auto 
Keyword Property ActorTypeGhost  Auto 
Keyword Property ActorTypeDwarven  Auto 
Keyword Property ActorTypeAnimal  Auto 
Keyword Property ActorTypeNPC  Auto 
Keyword Property ActorTypeCreature  Auto 
Keyword Property Vampire  Auto 

GlobalVariable Property zMFgHogMode  Auto
GlobalVariable Property zMFgAllow0xFF Auto

Keyword Property HogLink  Auto
Faction Property HogMasterFaction  Auto

MiscObject Property moBackToCage Auto
MiscObject Property moInventory Auto
MiscObject Property moCattleRank Auto
MiscObject Property moBreeding2P Auto
MiscObject Property moBreeding3P Auto
MiscObject Property moBreeding4P Auto
MiscObject Property moBreeding5P Auto

MiscObject Property moStatus01 Auto
MiscObject Property moStatus02 Auto
MiscObject Property moStatus03 Auto
MiscObject Property moStatus04 Auto
MiscObject Property moStatus05 Auto
MiscObject Property moStatus06 Auto

Message Property MsgSoulFundMenu  Auto
Message Property MsgGoldShortage  Auto
Message Property MsgSoulPerkMenu  Auto
Message Property MsgSoulShortage  Auto
Message Property MsgTimeScaleMenu  Auto 
MiscObject Property mABOpiton01  Auto
MiscObject Property mABOpiton02  Auto
MiscObject Property mABOpiton03  Auto
MiscObject Property mABOpiton04  Auto
MiscObject Property mABOpiton05  Auto
MiscObject Property mABOption06  Auto  

MiscObject Property Gold001  Auto

;-------------------------------------------------

;--------------------------------------------------
;Ref
;--------------------------------------------------
Bool Function IsValidRef(ObjectReference o)
	if o == None || o == BlankNameObject
		return false
	elseif (o as Actor).IsDisabled()||(o as Actor).IsDeleted()
		return false
	else
		return true
	endif
EndFunction


Bool Function IsEmptyRef(ObjectReference o)
	if o == None || o == BlankNameObject
		return true
	else
		return false
	endif
EndFunction


;--------------------------------------------------
;Harvest
;--------------------------------------------------
Form Function GetHarvestForm(Actor a)
Form[] CrHarverst =  ListHarvestCreature.ToArray()
Form[] HarvestHum = ListHarvestHuman.ToArray()

	if a.HasKeyword(ActorTypeNPC) ;HumanType

		if a.HasKeyword(ActorTypeGhost)
			Return HarvestHum[1]

		elseif a.HasKeyword(Vampire)
			Return HarvestHum[2]

		elseif a.HasKeyword(ActorTypeDaedra)
			Return CrHarverst[12]

		elseif a.HasKeyword(ActorTypeDwarven)
			Return CrHarverst[14]

		elseif a.HasKeyword(ActorTypeUndead)
			Return CrHarverst[31]

		else
			Return HarvestHum[0]
		endif

	else 
		;Creature
		VoiceType myVoice = a.GetLeveledActorBase().GetVoiceType()
		Form[] CrVoiceArray = ListCreatureVoice.ToArray()
		int i = CrVoiceArray.Find(myVoice)
		if i >= 0 ;Creature Voice
			Return  CrHarverst[i]

		elseif a.HasKeyword(ActorTypeGhost)
			Return HarvestHum[1]

		elseif a.HasKeyword(Vampire)
			Return HarvestHum[2]

		elseif a.HasKeyword(ActorTypeDaedra)
			Return CrHarverst[12]

		elseif a.HasKeyword(ActorTypeDwarven)
			Return CrHarverst[14]

		elseif a.HasKeyword(ActorTypeUndead)
			Return CrHarverst[31]

		else
			Return LItemDefault
		endif
	endif
		
EndFunction

Form Function GetMilkForm(Actor a)
	Form[] HarvestArray = ListMilk.ToArray()

	if a.HasKeyword(ActorTypeDaedra)
		return HarvestArray[4]

	elseif a.HasKeyword(Vampire)
		return HarvestArray[3]

	elseif a.HasKeyword(ActorTypeUndead)
		return HarvestArray[2]

	elseif a.HasKeyword(ActorTypeDwarven)
		return HarvestArray[1]
	else
		return HarvestArray[0]
	endif
EndFunction

Function AddHarvestTo(ObjectReference o, actor a, actor b)
	if !o  ||  IsEmptyRef(a) ||  IsEmptyRef(b)
		return
	endif

	Form aItem = GetHarvestForm(a)
	Form bItem = GetHarvestForm(b)
	int HarvestPercent = GetAffinity(a,b)


	if !aItem && !bItem || HarvestPercent <= 0
		return
	endif

	if HarvestPercent >= Utility.RandomINT(0,100)
		o.Additem(LitemToken,1)
	endif

	While HarvestPercent >= 0
		if HarvestPercent >= Utility.RandomINT(0,100)
			if aItem  
				o.AddItem(aItem,1)
			endif
			if bItem
				o.AddItem(bItem,1)
			endif
		endif
		HarvestPercent -=100
	endwhile

	; Milking
	AddMilk(o, a)
	AddMilk(o, b)

	Domesticate(a)
	Domesticate(b)
EndFunction

;--------------------------------------------------
;Token
;--------------------------------------------------
Int Function GetRearingCost(Actor a)
	float H = a.GetActorValue("Health")*0.5* (1+ (a.GetItemCount(TokenMilk) as float)*0.1)
	if H<= 0.0
		H= 1.0
	endif
	Return  H as int 
EndFunction

Int Function GetMotivation(Actor a)
	float S = a.GetActorValue("Stamina")*0.2 + a.GetItemCount(TokenMotivation)*10 + GetTrained(a)*0.1
	if S < 0.0
		S = 0.0
	endif
	Return S as int
EndFunction

Int Function GetEstrus(Actor a)
	float M = a.GetActorValue("Magicka")*0.2 + a.GetItemCount(TokenEstrus)*10 + GetTrained(a)*0.2
	if M < 0.0
		M = 0.0
	endif
	Return M as int
EndFunction

Int Function GetTrained(Actor a)
	Return a.GetItemCount(TokenTrained)
EndFunction

Function AddMilk(objectReference o, actor a)
	int Count = a.GetItemCount(TokenMilk)
	if Count <=0
		return
	else
		o.Additem(GetMilkForm(a), Count)
	endif
EndFunction

Function Domesticate(Actor a, int mult = 1)
	int tp = GetTrained(a)

	if tp >= 1000
		return
	else
		int dom = (5+ (GetMotivation(a)+GetEstrus(a))/10)*mult
		if tp + dom > 1000
			dom = 1000 - tp
		endif
		a.AddItem(TokenTrained, dom)
		return
	endif
EndFunction

Int Function GetProductivity(Actor a)
	float m =  1+GetMotivation(a)*0.01
	float p = a.GetItemCount(TokenProductive)*10.0

	float Total = (a.GetActorValue("Health")*0.25+ p)* m

	return (Total as int)
EndFunction

Int Function GetAffinity(Actor a, Actor b)
	if  IsEmptyRef(a) || IsEmptyRef(b)
		return 0
	endif
	
	Float Matchbase = 10
	if a.GetLeveledActorBase().GetRace() == b.GetLeveledActorBase().GetRace()
		Matchbase = 75

	elseif a.HasKeyword(ActorTypeNPC) && b.HasKeyword(ActorTypeNPC)
		Matchbase = 50

	elseif a.HasKeyword(ActorTypeCreature) && b.HasKeyword(ActorTypeCreature)
		Matchbase = 25
	endif
	Float Estrus = (GetEstrus(a)+GetEstrus(b))*0.5
	Float total = (Matchbase+ Estrus)

	Return (total as int)
EndFunction

Int[] Function GetStatusStock(Actor a, Actor b = None)
	Int[] x = new Int[6]
		x[0]= GetRearingCost(a)
		x[1]= GetProductivity(a)
		x[2]= GetMotivation(a)
		x[3]= GetEstrus(a)
		x[4]= GetTrained(a)
		x[5]= GetAffinity(a, b)
	return x
EndFunction

Int[] Function GetAccount(ReferenceAlias[] AliasList)
	int index = AliasList.Length - 1
	int Cost = 0
	int Prod = 0
	ReferenceAlias tmpAlias
	Actor tmpActor

	while index >= 0
		tmpAlias = AliasList[index]
		tmpActor = tmpAlias.GetActorRef()
		if !IsEmptyRef(tmpActor)
			Cost += GetRearingCost(tmpActor)
			Prod += GetProductivity(tmpActor)
		endif
		index -=1
	endwhile

	int[] Account = new int[3]
	Account[0]=Cost
	Account[1]=Prod
	Account[2]=Prod - Cost

	Return Account
EndFunction

;--------------------------------------------------
;Alias
;--------------------------------------------------

Function ClearAliasAndName(ReferenceAlias rA)
	if !rA.GetRef()
		return
	endif
	rA.ForceRefTo(BlankNameObject)
	rA.Clear()
EndFunction

int Function FindEmptyAlias(ReferenceAlias[] AliasList)
	int index=0
	int Max=AliasList.Length - 1
	ReferenceAlias tmpAlias

	while index <= Max
		tmpAlias = AliasList[index]
		if IsEmptyRef(tmpAlias.GetRef())
			return index	
		else
			index += 1	
		endif
	endwhile
	return -1
EndFunction

Function InitAlisaList(ReferenceAlias[] AliasList)
	int index=AliasList.Length - 1
	ReferenceAlias tmpAlias

	while index >= 0
		tmpAlias = AliasList[index]
		ClearAliasAndName(tmpAlias)
		index -= 1
	endWhile
EndFunction

Function RemoveInvalidRefFromAliasList(ReferenceAlias[] AliasList)
	int index=AliasList.Length - 1
	ReferenceAlias tmpAlias
	Actor tmpActor

	while index >=0
		tmpAlias = AliasList[index]
		tmpActor = tmpAlias.GetActorRef()
		if tmpActor != BlankNameObject
			if tmpActor == None || tmpActor.IsDisabled() || tmpActor.IsDeleted()
				ClearAliasAndName(tmpAlias)
			endif
		endif
		index -= 1
	endWhile
EndFunction

Bool Function IsEmptyAliasList(ReferenceAlias[] AliasList)
	int ListSize = AliasList.Length 
	int index = ListSize - 1
	int counter = 0
	ReferenceAlias tmpAlias

	while index >= 0
		tmpAlias = AliasList[index]
		if IsEmptyRef(tmpAlias.GetRef())
			counter +=1
		endif
		index -=1
	endWhile

	if counter >= ListSize
		return true
	else
		return false
	endif
EndFunction


;--------------------------------------------------
;Hog
;--------------------------------------------------

Bool Function IsHogMode()
	if zMFgHogMode.GetValue() == 0
		return False
	else
		return True
	endif
EndFunction

Bool Function IsHogMaster(Actor hog)
	if hog.HasKeyword(HogLink) || hog.IsInFaction(HogMasterFaction)
		Return True
	else
		Return False
	endif
EndFunction

int Function CountLinkedHogs(ObjectReference hog)
	if IsHogMaster(hog as Actor)
		Return hog.countLinkedRefChain(None, 4)
	else
		Return 0
	endif
EndFunction



